Release 0.8.14
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
ec7f904e 82aptmark() { runapt apt-mark $*; }
158fda31
DK
83dpkg() {
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
85}
b6b5a542
DK
86aptitude() {
87 if [ -f ./aptconfig.conf ]; then
88 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
89 elif [ -f ../aptconfig.conf ]; then
90 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
91 else
92 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
93 fi
94}
8d876415 95
b720d0bd
DK
96addtrap() {
97 CURRENTTRAP="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
99}
8d876415
DK
100
101setupenvironment() {
75954ae2 102 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 103 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 104 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 105 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
107 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 108 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 109 cd $TMPWORKINGDIRECTORY
cd725954 110 mkdir rootdir aptarchive keys
8d876415 111 cd rootdir
b29c3712
DK
112 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
113 mkdir -p var/cache var/lib var/log
cffea9af 114 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 115 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 else
119 touch var/lib/dpkg/status
120 fi
cd725954 121 touch var/lib/dpkg/available
8d876415
DK
122 mkdir -p usr/lib/apt
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 cd ..
2c6baa5a 125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 128 fi
4a4ea26c
AM
129 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 132 fi
cd725954
DK
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 135 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 136 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
137 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
138 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 139 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
140 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
147 export LC_ALL=C
148 msgdone "info"
149}
150
151configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT::Architecture \"$1\";" > $CONFFILE
154 shift
155 while [ -n "$1" ]; do
156 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
157 shift
158 done
159}
160
75954ae2 161setupsimplenativepackage() {
ce9864a8
DK
162 local NAME="$1"
163 local ARCH="$2"
164 local VERSION="$3"
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
b7899b00
DK
168 local SECTION="${7:-others}"
169 local DISTSECTION
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
171 DISTSECTION="main"
172 else
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
174 fi
ce9864a8
DK
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
177 cd ${BUILDDIR}
178 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
181
182 * Initial release
183
b7899b00
DK
184 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source: $NAME
186Section: $SECTION
ce9864a8
DK
187Priority: optional
188Maintainer: Joe Sixpack <joe@example.org>
189Build-Depends: debhelper (>= 7)
190Standards-Version: 3.9.1
191
875bcb36
DK
192Package: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture: all" >> debian/control
195 else
196 echo "Architecture: any" >> debian/control
197 fi
ce9864a8
DK
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
201 If you find such a package installed on your system,
202 YOU did something horribly wrong! They are autogenerated
203 und used only by testcases for APT and surf no other propose…" >> debian/control
204 else
205 echo "Description: $DESCRIPTION" >> debian/control
206 fi
b7899b00
DK
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
210 cd - > /dev/null
211}
212
213buildsimplenativepackage() {
214 local NAME="$1"
215 local ARCH="$2"
216 local VERSION="$3"
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
221 local DISTSECTION
222 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
223 DISTSECTION="main"
224 else
225 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
226 fi
5a635ee4 227 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 228
18331adf 229 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
230 mkdir -p $BUILDDIR/debian/source
231 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
232 echo "#!/bin/sh
233echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
234
235 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
236 echo "$NAME ($VERSION) $RELEASE; urgency=low
237
238 * Initial release
239
240 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
241 echo "Source: $NAME
242Section: $SECTION
243Priority: optional
244Maintainer: Joe Sixpack <joe@example.org>
245Standards-Version: 3.9.1
246
875bcb36
DK
247Package: $NAME" > ${BUILDDIR}/debian/control
248 if [ "$ARCH" = 'all' ]; then
249 echo "Architecture: all" >> ${BUILDDIR}/debian/control
250 else
251 echo "Architecture: any" >> ${BUILDDIR}/debian/control
252 fi
b761356f
DK
253 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
254 if [ -z "$DESCRIPTION" ]; then
255 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
256 If you find such a package installed on your system,
257 YOU did something horribly wrong! They are autogenerated
258 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
259 else
260 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
261 fi
262 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
263 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 264 for SRC in $SRCS; do
5a635ee4 265 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 266 done
84aa13f4
DK
267
268 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
269 rm -rf ${BUILDDIR}/debian/tmp
270 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
271 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
272 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
273 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
274 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
275
276 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
277 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
278 done
279
13845042
DK
280 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
281 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
282 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 283 rm -rf "${BUILDDIR}"
b761356f 284 msgdone "info"
75954ae2
DK
285}
286
287buildpackage() {
288 local BUILDDIR=$1
289 local RELEASE=$2
290 local SECTION=$3
291 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
292 cd $BUILDDIR
293 if [ "$ARCH" = "all" ]; then
294 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
295 fi
b7899b00
DK
296 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
297 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 298 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 299 cd - > /dev/null
b7899b00 300 for PKG in $PKGS; do
75954ae2 301 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
302 done
303 for SRC in $SRCS; do
75954ae2 304 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 305 done
cffea9af 306 msgdone "info"
ce9864a8
DK
307}
308
309buildaptarchive() {
ce9864a8
DK
310 if [ -d incoming ]; then
311 buildaptarchivefromincoming $*
312 else
313 buildaptarchivefromfiles $*
314 fi
315}
316
317createaptftparchiveconfig() {
318 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
319 if [ -z "$ARCHS" ]; then
320 # the pool is empty, so we will operate on faked packages - let us use the configured archs
321 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
322 fi
ce9864a8
DK
323 echo -n 'Dir {
324 ArchiveDir "' >> ftparchive.conf
325 echo -n $(readlink -f .) >> ftparchive.conf
326 echo -n '";
327 CacheDir "' >> ftparchive.conf
328 echo -n $(readlink -f ..) >> ftparchive.conf
329 echo -n '";
b7899b00
DK
330 FileListDir "' >> ftparchive.conf
331 echo -n $(readlink -f pool/) >> ftparchive.conf
332 echo -n '";
333};
334Default {
bc33e0f0
DK
335 Packages::Compress ". gzip bzip2 lzma xz";
336 Sources::Compress ". gzip bzip2 lzma xz";
337 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 338 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 339 LongDescription "false";
ce9864a8
DK
340};
341TreeDefault {
342 Directory "pool/";
343 SrcDirectory "pool/";
344};
345APT {
346 FTPArchive {
347 Release {
348 Origin "joesixpack";
349 Label "apttestcases";
350 Suite "unstable";
351 Description "repository with dummy packages";
352 Architectures "' >> ftparchive.conf
353 echo -n "$ARCHS" >> ftparchive.conf
354 echo 'source";
355 };
356 };
357};' >> ftparchive.conf
b7899b00
DK
358 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
359 echo -n 'tree "dists/' >> ftparchive.conf
360 echo -n "$DIST" >> ftparchive.conf
361 echo -n '" {
ce9864a8
DK
362 Architectures "' >> ftparchive.conf
363 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
364 echo -n 'source";
365 FileList "' >> ftparchive.conf
366 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
367 echo -n '";
368 SourceFileList "' >> ftparchive.conf
369 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
370 echo -n '";
371 Sections "' >> ftparchive.conf
372 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
373 echo '";
ce9864a8 374};' >> ftparchive.conf
b7899b00 375 done
ce9864a8
DK
376}
377
378buildaptftparchivedirectorystructure() {
b7899b00
DK
379 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
380 for DIST in $DISTS; do
381 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
382 for SECTION in $SECTIONS; do
383 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
384 for ARCH in $ARCHS; do
385 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
386 done
387 mkdir -p dists/${DIST}/${SECTION}/source
388 mkdir -p dists/${DIST}/${SECTION}/i18n
389 done
ce9864a8 390 done
ce9864a8
DK
391}
392
9b78cda6
DK
393insertpackage() {
394 local RELEASE="$1"
395 local NAME="$2"
396 local ARCH="$3"
397 local VERSION="$4"
398 local DEPENDENCIES="$5"
399 local ARCHS="$ARCH"
400 if [ "$ARCHS" = "all" ]; then
401 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
402 fi
403 for BUILDARCH in $ARCHS; do
404 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
405 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
406 touch aptarchive/dists/${RELEASE}/main/source/Sources
407 local FILE="${PPATH}/Packages"
408 echo "Package: $NAME
409Priority: optional
410Section: other
2c085486 411Installed-Size: 42
9b78cda6
DK
412Maintainer: Joe Sixpack <joe@example.org>
413Architecture: $ARCH
2c085486
DK
414Version: $VERSION
415Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
416 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
417 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
418 If you find such a package installed on your system,
419 YOU did something horribly wrong! They are autogenerated
420 und used only by testcases for APT and surf no other propose…
421" >> $FILE
422 done
423}
424
dfc2b1be
DK
425insertinstalledpackage() {
426 local NAME="$1"
427 local ARCH="$2"
428 local VERSION="$3"
429 local DEPENDENCIES="$4"
430 local FILE="rootdir/var/lib/dpkg/status"
431 echo "Package: $NAME
432Status: install ok installed
433Priority: optional
434Section: other
435Installed-Size: 42
436Maintainer: Joe Sixpack <joe@example.org>
437Architecture: $ARCH
438Version: $VERSION" >> $FILE
439 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
440 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
441 If you find such a package installed on your system,
442 YOU did something horribly wrong! They are autogenerated
443 und used only by testcases for APT and surf no other propose…
444" >> $FILE
445}
446
447
ce9864a8 448buildaptarchivefromincoming() {
3cbbda3c 449 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
450 cd aptarchive
451 [ -e pool ] || ln -s ../incoming pool
452 [ -e ftparchive.conf ] || createaptftparchiveconfig
453 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 454 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 455 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
456 cd - > /dev/null
457 msgdone "info"
9b78cda6 458 generatereleasefiles
ce9864a8
DK
459}
460
461buildaptarchivefromfiles() {
3cbbda3c 462 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
463 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
464 msgninfo "\t${line} file… "
465 cat ${line} | gzip > ${line}.gz
466 cat ${line} | bzip2 > ${line}.bz2
467 cat ${line} | lzma > ${line}.lzma
b7080ced 468 cat ${line} | xz > ${line}.xz
8d876415 469 msgdone "info"
9b78cda6
DK
470 done
471 generatereleasefiles
472}
473
474generatereleasefiles() {
475 msgninfo "\tGenerate Release files… "
fe0f7911 476 local DATE="${1:-now}"
9b78cda6 477 if [ -e aptarchive/dists ]; then
18331adf
DK
478 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
479 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
480 done
9b78cda6 481 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 482 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
483 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
484 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
485 sed -i '/^Date: / a\
486NotAutomatic: yes' $dir/Release
487 fi
9b78cda6
DK
488 done
489 else
490 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 491 fi
fe0f7911
DK
492 if [ "$DATE" != "now" ]; then
493 for release in $(find ./aptarchive -name 'Release'); do
494 touch -d "$1" $release
495 done
8d876415 496 fi
b7899b00 497 msgdone "info"
8d876415
DK
498}
499
b7899b00
DK
500setupdistsaptarchive() {
501 local APTARCHIVE=$(readlink -f ./aptarchive)
502 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
503 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
504 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
505 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
506 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
507 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
508 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
509 msgdone "info"
510 done
511}
512
513setupflataptarchive() {
ce9864a8 514 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
515 if [ -f ${APTARCHIVE}/Packages ]; then
516 msgninfo "\tadd deb sources.list line… "
517 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
518 msgdone "info"
519 else
520 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
521 fi
522 if [ -f ${APTARCHIVE}/Sources ]; then
523 msgninfo "\tadd deb-src sources.list line… "
524 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
525 msgdone "info"
526 else
527 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
528 fi
b7899b00
DK
529}
530
531setupaptarchive() {
532 buildaptarchive
533 if [ -e aptarchive/dists ]; then
534 setupdistsaptarchive
535 else
536 setupflataptarchive
537 fi
f213b6ea 538 signreleasefiles
cd725954 539 msgninfo "\tSync APT's cache with the archive… "
8d876415 540 aptget update -qq
cd725954 541 msgdone "info"
8d876415
DK
542}
543
f213b6ea
DK
544signreleasefiles() {
545 local SIGNER="${1:-Joe Sixpack}"
546 msgninfo "\tSign archive with $SIGNER key… "
547 local SECKEYS=""
548 for KEY in $(find keys/ -name '*.sec'); do
549 SECKEYS="$SECKEYS --secret-keyring $KEY"
550 done
551 local PUBKEYS=""
552 for KEY in $(find keys/ -name '*.pub'); do
553 PUBKEYS="$PUBKEYS --keyring $KEY"
554 done
555 for RELEASE in $(find aptarchive/ -name Release); do
556 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 557 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
558 done
559 msgdone "info"
560}
561
562changetowebserver() {
563 if which weborf > /dev/null; then
564 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 565 addtrap "kill $!;"
f213b6ea
DK
566 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
567 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
568 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
569 done
570 return 0
571 fi
572 return 1
573}
574
575checkdiff() {
8d876415
DK
576 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
577 if [ -n "$DIFFTEXT" ]; then
578 echo
579 echo "$DIFFTEXT"
580 return 1
581 else
582 return 0
583 fi
584}
585
75954ae2
DK
586testfileequal() {
587 local FILE="$1"
588 shift
589 msgtest "Test for correctness of file" "$FILE"
590 if [ -z "$*" ]; then
f213b6ea 591 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 592 else
f213b6ea 593 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
594 fi
595}
596
8d876415
DK
597testequal() {
598 local COMPAREFILE=$(mktemp)
b720d0bd 599 addtrap "rm $COMPAREFILE;"
8d876415
DK
600 echo "$1" > $COMPAREFILE
601 shift
602 msgtest "Test for equality of" "$*"
f213b6ea 603 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
604}
605
685625bd
DK
606testequalor2() {
607 local COMPAREFILE1=$(mktemp)
608 local COMPAREFILE2=$(mktemp)
609 local COMPAREAGAINST=$(mktemp)
b720d0bd 610 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
611 echo "$1" > $COMPAREFILE1
612 echo "$2" > $COMPAREFILE2
613 shift 2
614 msgtest "Test for equality OR of" "$*"
615 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
616 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
617 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
618 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
619 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
620 msgfail )
621}
622
8d876415 623testshowvirtual() {
edc0ef10 624 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
625 local PACKAGE="$1"
626 shift
627 while [ -n "$1" ]; do
628 VIRTUAL="${VIRTUAL}
edc0ef10 629N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
630 PACKAGE="${PACKAGE} $1"
631 shift
632 done
633 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
634 VIRTUAL="${VIRTUAL}
4bec02c2 635N: No packages found"
8d876415 636 local COMPAREFILE=$(mktemp)
b720d0bd 637 addtrap "rm $COMPAREFILE;"
8d876415
DK
638 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
639 eval `apt-config shell ARCH APT::Architecture`
640 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 641 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
642}
643
644testnopackage() {
645 msgtest "Test for non-existent packages" "apt-cache show $*"
646 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
647 if [ -n "$SHOWPKG" ]; then
648 echo
649 echo "$SHOWPKG"
650 msgfail
651 return 1
652 fi
653 msgpass
654}
01a6e24c
DK
655
656testdpkginstalled() {
657 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
658 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
659 if [ "$PKGS" != $# ]; then
01a6e24c
DK
660 echo $PKGS
661 dpkg -l $* | grep '^[a-z]'
662 msgfail
663 return 1
664 fi
665 msgpass
666}
667
5cf733e1
DK
668testdpkgnotinstalled() {
669 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 670 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
671 if [ "$PKGS" != 0 ]; then
672 echo
673 dpkg -l $* | grep '^[a-z]'
674 msgfail
675 return 1
676 fi
677 msgpass
678}
ec7f904e
DK
679
680testmarkedauto() {
681 local COMPAREFILE=$(mktemp)
682 addtrap "rm $COMPAREFILE;"
683 if [ -n "$1" ]; then
684 msgtest 'Test for correctly marked as auto-installed' "$*"
685 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
686 else
687 msgtest 'Test for correctly marked as auto-installed' 'no package'
688 echo > $COMPAREFILE
689 fi
690 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
691}